<?php
if (!class_exists('Onepxeyemkd_settings')) {
    class Onepxeyemkd_settings
    {
        public function __construct()
        {
            add_action('add_meta_boxes', array(
                $this,
                'add_meta_box',
            ));
            add_action('save_post', array(
                $this,
                'save',
            ));
            add_action('admin_menu', array($this, 'onepeye_mkd'));
            add_action('admin_init', array($this, 'Onepxeyemkd_term_fields'));
        }

        public function Onepxeyemkd_term_fields()
        {
            $mkd_post_types = get_option('mkd_posttypes');
            $mkd_taxes = get_object_taxonomies($mkd_post_types);
            if (empty($mkd_taxes)) {
                $mkd_taxes = array();
            }
            foreach ($mkd_taxes as $mkd_tax) {
                add_action($mkd_tax . '_add_form_fields', function ($tag) {
                    $mkd_term_title = get_term_meta(@$tag->term_id, '_mkd_term_title', true);
                    $mkd_term_keywords = get_term_meta(@$tag->term_id, '_mkd_term_keywords', true);
                    $mkd_term_description = get_term_meta(@$tag->term_id, '_mkd_term_description', true);?>
<div class="form-field term-mkd-title-wrap">
    <label for='cat_page_title'><?php _e('Custom Title');?></label>
    <input type="text" name="mkd_term_title" id="mkd_term_title" value="<?php echo $mkd_term_title; ?>" />
</div>
<div class="form-field term-mkd-description-wrap">
    <label for='cat_page_title'><?php _e('Meta Description');?></label>
    <textarea name='mkd_term_description' id='mkd_term_description'><?php echo $mkd_term_description; ?></textarea>
</div>
<div class="form-field term-mkd-keywords-wrap">
    <label for='cat_page_title'><?php _e('Meta Keywords');?></label>
    <input type="text" name="mkd_term_keywords" id="mkd_term_keywords" value="<?php echo $mkd_term_keywords; ?>" />
</div>
<?php
});
                add_action($mkd_tax . '_edit_form_fields', function ($tag) {
                    $mkd_term_title = get_term_meta($tag->term_id, '_mkd_term_title', true);
                    $mkd_term_keywords = get_term_meta($tag->term_id, '_mkd_term_keywords', true);
                    $mkd_term_description = get_term_meta($tag->term_id, '_mkd_term_description', true);
                    ?>
<tr class='form-field'>
    <th scope='row'><label for='cat_page_title'><?php _e('Custom Title');?></label></th>
    <td>
        <input type="text" name="mkd_term_title" id="mkd_term_title" value="<?php echo $mkd_term_title; ?>" />
    </td>
</tr>
<tr class='form-field'>
    <th scope='row'><label for='cat_page_title'><?php _e('Meta Description');?></label></th>
    <td>
        <textarea name='mkd_term_description' id='mkd_term_description'><?php echo $mkd_term_description; ?></textarea>
    </td>
</tr>
<tr class='form-field'>
    <th scope='row'><label for='cat_page_title'><?php _e('Meta Keywords');?></label></th>
    <td>
        <input type="text" name="mkd_term_keywords" id="mkd_term_keywords" value="<?php echo $mkd_term_keywords; ?>" />
    </td>
</tr>
<?php
});
                add_action('edited_' . $mkd_tax, function ($term_id) {
                    if (isset($_POST['mkd_term_title'])) {
                        update_term_meta($term_id, '_mkd_term_title', $_POST['mkd_term_title']);
                    }
                    if (isset($_POST['mkd_term_keywords'])) {
                        update_term_meta($term_id, '_mkd_term_keywords', $_POST['mkd_term_keywords']);
                    }
                    if (isset($_POST['mkd_term_description'])) {
                        update_term_meta($term_id, '_mkd_term_description', $_POST['mkd_term_description']);
                    }
                });
                add_action('create_' . $mkd_tax, function ($term_id) {
                    if (isset($_POST['mkd_term_title'])) {
                        update_term_meta($term_id, '_mkd_term_title', $_POST['mkd_term_title']);
                    }
                    if (isset($_POST['mkd_term_keywords'])) {
                        update_term_meta($term_id, '_mkd_term_keywords', $_POST['mkd_term_keywords']);
                    }
                    if (isset($_POST['mkd_term_description'])) {
                        update_term_meta($term_id, '_mkd_term_description', $_POST['mkd_term_description']);
                    }
                });
            }
        }
        public function onepeye_mkd()
        {
            add_menu_page(
                'Meta keywords and description',
                'Meta keywords and description',
                'manage_options',
                'mkd-description-settings',
                array($this, 'set_meta_description'),
                'dashicons-editor-code',
                3
            );
            add_action('admin_init', array($this, 'save_mkd_description_settings'));
        }
        public function set_meta_description()
        {
            require plugin_dir_path(__FILE__) . '../meta/description-admin.php';
        }
        public function save_mkd_description_settings()
        {
            register_setting('mkd-description-settings-group', 'mkd_posttypes');
            register_setting('mkd-description-settings-group', 'mkd_home_description');
            register_setting('mkd-description-settings-group', 'mkd_home_keywords');
            register_setting('mkd-description-settings-group', 'mkd_global_description');
            register_setting('mkd-description-settings-group', 'mkd_global_keywords');
            register_setting('mkd-description-settings-group', 'remove_mkd_data_on_uninstall');
            add_settings_section('mkd-active-post-type', 'Activated Post type', array($this, 'mkd_posttype_options'), 'mkd-posttype-settings');
            add_settings_field('active-post-type', '<strong>Post Types</strong>', array($this, 'mkd_posttype_settings'), 'mkd-posttype-settings', 'mkd-active-post-type');
            add_settings_section('mkd-home-setting', 'Home / Front page settings', array($this, 'mkd_home_options'), 'mkd-home-settings');
            add_settings_field('home-description', '<strong>Description</strong>', array($this, 'mkd_home_description_text'), 'mkd-home-settings', 'mkd-home-setting');
            add_settings_field('home-keywords', '<strong>Keywords</strong>', array($this, 'mkd_home_keywords_text'), 'mkd-home-settings', 'mkd-home-setting');
            add_settings_section('mkd-global-setting', 'Default meta keywords and description', array($this, 'mkd_global_options'), 'mkd-global-settings');
            add_settings_field('global-description-text', '<strong>Description</strong>', array($this, 'mkd_global_description_text'), 'mkd-global-settings', 'mkd-global-setting');
            add_settings_field('global-keywords-text', '<strong>Keywords</strong>', array($this, 'mkd_global_keywords_text'), 'mkd-global-settings', 'mkd-global-setting');
            add_settings_section('mkd-remove-uninstall', 'Misc', array($this, 'mkd_remove_uninstall_options'), 'mkd-remove_uninstall-settings');
            add_settings_field('remove-data-mkd', '<strong>Remove Data</strong>', array($this, 'mkd_remove_uninstall_settings'), 'mkd-remove_uninstall-settings', 'mkd-remove-uninstall');
        }
        public function add_meta_box($post_type)
        {
            $mkd_post_types = get_option('mkd_posttypes');
            if (empty($mkd_post_types)) {
                $mkd_post_types = array();
            }
            $post_types = $mkd_post_types;
            if (empty($post_types)) {
                $post_types = array();
            }
            if (in_array($post_type, $post_types)) {
                add_meta_box('mkd_post_settings', 'Meta Keywords and Desciption settings', array(
                    $this,
                    'render_mkd_settings',
                ), $post_type, 'normal', 'default');
            }
        }
        public function render_mkd_settings($post)
        {
            $mkd_title_field = get_post_meta($post->ID, '_mkd_title_field', true);
            $mkd_keywords_field = get_post_meta($post->ID, '_mkd_keywords_field', true);
            $mkd_description_field = get_post_meta($post->ID, '_mkd_description_field', true);
            ?>
<div class="mkd-keywords">
    <h4>Custom Title</h4>
    <input type="text" name="mkd_title_field" value="<?php echo $mkd_title_field; ?>" />
</div>
<div class="mkd-keywords">
    <h4>Meta Keywords</h4>
    <input type="text" name="mkd_keywords_field" value="<?php echo $mkd_keywords_field; ?>" />
</div>
<div class="mkd-description-textarea">
    <h4>Meta Descrition</h4>
    <textarea name="mkd_description_field"><?php echo $mkd_description_field; ?></textarea>
</div>
<?php
}
        public function save($post_id)
        {
            if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
                return $post_id;
            }
            if (isset($_POST['post_type']) && 'page' == $_POST['post_type']) {
                if (!current_user_can('edit_page', $post_id)) {
                    return $post_id;
                }
            } else {
                if (!current_user_can('edit_post', $post_id)) {
                    return $post_id;
                }
            }
            update_post_meta($post_id, '_mkd_title_field', !empty($_POST['mkd_title_field']) ? $_POST['mkd_title_field'] : "");
            update_post_meta($post_id, '_mkd_description_field', !empty($_POST['mkd_description_field']) ? $_POST['mkd_description_field'] : "");
            update_post_meta($post_id, '_mkd_keywords_field', !empty($_POST['mkd_keywords_field']) ? $_POST['mkd_keywords_field'] : "");
        }
        public function mkd_posttype_settings()
        {
            $mkd_posttypes = get_option('mkd_posttypes');
            if (empty($mkd_posttypes)) {
                $mkd_posttypes = array();
            }
            $args = array(
                'public' => true,
                // '_builtin' => false,
            );
            $output = 'names';
            $operator = 'or';
            $post_types = array();
            foreach (get_post_types($args, $output, $operator) as $post_type) {
                $post_types[] = $post_type;
            }
            $post_types_array = \array_diff($post_types, ["attachment", "revision", "es_template", "rl_gallery"]);
            $post_types_array = array_values($post_types_array);
            echo '<div class="labels">';
            foreach ($post_types_array as $pt) {
                ?>
<label for="<?php echo $pt; ?>"><input type="checkbox" name="mkd_posttypes[]" value="<?php echo $pt; ?>"
        id="<?php echo $pt; ?>" <?php if (in_array($pt, $mkd_posttypes)) {echo 'checked';}?>><?php echo $pt; ?></label>
<?php
}
            echo '</div>';
            ?>
<?php
}
        public function mkd_home_description_text()
        {
            $mkd_home_description = get_option('mkd_home_description');
            ?>
<textarea name="mkd_home_description"><?php echo esc_attr($mkd_home_description); ?></textarea>
<?php
}
        public function mkd_home_keywords_text()
        {
            $mkd_home_keywords = get_option('mkd_home_keywords');
            ?>
<input type="text" value="<?php echo esc_attr($mkd_home_keywords); ?>" name="mkd_home_keywords">
<div class="mkd-des-text">Seperate words by comma ','</div>
<?php
}
        public function mkd_global_description_text()
        {
            $mkd_global_description = get_option('mkd_global_description');
            ?>
<textarea name="mkd_global_description"><?php echo esc_attr($mkd_global_description); ?></textarea>
<?php
}
        public function mkd_global_keywords_text()
        {
            $mkd_global_keywords = get_option('mkd_global_keywords');
            ?>
<input type="text" value="<?php echo esc_attr($mkd_global_keywords); ?>" name="mkd_global_keywords">
<div class="mkd-des-text">Seperate words by comma ','</div>
<?php
}
        public function mkd_home_options()
        {
        }
        public function mkd_posttype_options()
        {
        }
        public function mkd_global_options()
        {
        }
        public function mkd_remove_uninstall_options()
        {
        }
        public function mkd_remove_uninstall_settings()
        {
            $remove_mkd_data_on_uninstall = get_option('remove_mkd_data_on_uninstall');
            echo '<div class="labels">';
            ?>
<label><input type="checkbox" name="remove_mkd_data_on_uninstall" value="remove_data"
        <?php checked($remove_mkd_data_on_uninstall, 'remove_data');?>>Remove</label>
<?php echo '</div>';
            ?>
<div class="mkd-des-text">Check this box if you would like to completely remove all of its data when the plugin is
    deleted.</div>
<?php
}
    }
    if (class_exists('Onepxeyemkd_settings')) {
        $Onepxeyemkd_settings = new Onepxeyemkd_settings();
    }
}