<?php
if (!defined('WP_UNINSTALL_PLUGIN')) {
    die;
}

$remove_mkd_data_on_uninstall_confirm = get_option('remove_mkd_data_on_uninstall');
if(!empty($remove_mkd_data_on_uninstall_confirm) && $remove_mkd_data_on_uninstall_confirm == 'remove_data'){

global $wpdb;
$args = array(
    'public' => true,
);
$output = 'names';
$operator = 'or';
$post_types = array();
foreach (get_post_types($args, $output, $operator) as $post_type) {
    $post_types[] = $post_type;
}
$post_types_array = \array_diff($post_types, ["attachment", "revision", "es_template", "rl_gallery"]);
$post_types_array = array_values($post_types_array);
foreach ($post_types_array as $mkd_post_type) {
    $args = array(
        'numberposts' => -1,
        'post_type' => $mkd_post_type,
    );
    $posts = get_posts($args);
    foreach ($posts as $post) {
        delete_post_meta($post->ID, '_mkd_title_field');
        delete_post_meta($post->ID, '_mkd_keywords_field');
        delete_post_meta($post->ID, '_mkd_description_field'); 
    }
    $mkd_taxes = get_object_taxonomies($post_types_array);
    $mkd_terms = get_terms($mkd_taxes, array(
        'hide_empty' => false,
    ));
    foreach ($mkd_terms as $mkd_term) {
        delete_term_meta($mkd_term->term_id, '_mkd_term_title');
        delete_term_meta($mkd_term->term_id, '_mkd_term_keywords');
        delete_term_meta($mkd_term->term_id, '_mkd_term_description');
    }
}

delete_option('mkd_posttypes');
delete_option('mkd_home_descrition');
delete_option('mkd_home_keywords');
delete_option('mkd_global_description');
delete_option('mkd_global_keywords');
delete_option('mkd_global_keywords');
delete_option('remove_mkd_data_on_uninstall');

}